package ru.dbotthepony.mc.otm.compat.mekanism

import mekanism.api.math.FloatingLong
import ru.dbotthepony.mc.otm.core.math.Decimal
import java.math.BigInteger

private val LONG_OVERFLOW = BigInteger.valueOf(Long.MAX_VALUE) + BigInteger.valueOf(Long.MAX_VALUE) + BigInteger.TWO
private val LONG_OVERFLOW1 = BigInteger.valueOf(Long.MAX_VALUE) + BigInteger.valueOf(Long.MAX_VALUE) + BigInteger.ONE

fun Decimal.toFloatingLong(): FloatingLong {
	if (isNegative) {
		// Floating long can't be negative
		return FloatingLong.ZERO
	}

	if (whole >= LONG_OVERFLOW1) {
		return FloatingLong.MAX_VALUE
	}

	return FloatingLong.create(whole.toLong(), (decimal * 10_000.0).toInt().toShort())
}

fun FloatingLong.toDecimal(): Decimal {
	// Overflow
	if (value < 0L) {
		return Decimal(LONG_OVERFLOW + BigInteger.valueOf(value), decimal / 10_000.0)
	}

	return Decimal(value, decimal / 10_000.0)
}
